<!DOCTYPE html>
<html>
<head>
    <meta charset='utf-8'>
    <title>Lucky Dice Casino</title>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>
<style>
    .picture-cover {
        background-image: url("LuckyDiceImages/cover.jpg");
        min-height:100px;
        margin:5px;
    }
</style>
<body>
    <div class="container-fluid">
        <div class="picture-cover"></div>
    </div>
    <div class="container">
        <div class="row">
            <div class="col-sm-5">
                <div class="row form-group">
                    <div class="col-sm-12">
                        <h4>Nhập thông tin của bạn</h4>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label>Username</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="input-username" class="form-control" type="text" placeholder="Nhập username ...">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label>First name</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="input-first-name" class="form-control" type="text" placeholder="Nhập first name ...">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label>Last name</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="input-last-name" class="form-control" type="text" placeholder="Nhập last name ...">
                    </div>
                </div>
            </div>
            <div class="col-sm-4 text-center">
                <div class="row form-group">
                    <div class="col-sm-12">
                        <input id="btn-new-dice" class="btn btn-success button-width w-75" value="Ném" type="button">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-12">
                        <img id="img-dice" class="img-thumbnail" src="LuckyDiceImages/dice.png">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-12">
                        <p id="p-notification-dice">Bắt đầu ném</p>
                    </div>
                </div>
            </div>
            <div class="col-sm-3 text-center">
                <div class="row form-group">
                    <div class="col-sm-12">
                        <p>Voucher</p>
                        <p id="p-voucher-id">Không có Voucher</p>
                        <p id="p-voucher-percent">0%</p>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-12">
                        <img id="img-present" class="img-thumbnail" src="LuckyDiceImages/no-present.jpg">
                    </div>
                </div>
            </div>
        </div>
        <div class="form-group">
            <div class="row text-center">
                <div class="col-12">
                    <input id="btn-dice-history" class="btn btn-primary button-width w-25" value="Dice History" type="button">
                    <input id="btn-voucher-history" class="btn btn-primary button-width w-25" value="Voucher History" type="button">
                    <input id="btn-present-history" class="btn btn-primary button-width w-25" value="Present History" type="button">
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-12">
                <table id="table-history" class="table border table-striped table-hover">
                    <thead>
                        <tr>
                            <th>Lượt</th>
                            <th>Dice</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr>
                            <td></td>
                            <td></td>
                        </tr>
                        <tr>
                            <td></td>
                            <td></td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</body>
<script>
    "use strict";
    /*** Vùng 1: Biến toàn cục ***/
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://42.115.221.44:8080/devcamp-lucky-dice/";
    const gUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";

    /*** Vùng 2: gán sự kiện cho các phần tử */
    $("#btn-new-dice").click(onBtnNewDiceClick);
    $("#btn-dice-history").click(onBtnDiceHistoryClick);
    
    /*** Vùng 3: hàm xử lý sự kiện ***/
function onBtnNewDiceClick() { // hàm chạy khi ấn nút ném
    var vUserDataObj = {
        username: "",
        firstName: "",
        lastName: ""
    };
    getUserDataFromWeb(vUserDataObj); // lấy dữ liệu nhập từ web
    console.log("Ghi tạm dữ liệu nhập ra console");
    console.log(vUserDataObj);
    var vCheckResult = validateUserDataFromWeb(vUserDataObj); // kiểm tra dữ liệu nhập từ web
    console.log("Kết quả kiểm tra dữ liệu nhập là: " + vCheckResult);
    if (vCheckResult == true) {
        var vXmlHttp = new XMLHttpRequest(); // tạo request new dice
        callApiGetNewDice(vXmlHttp, vUserDataObj); // mở và gửi request new dice
        vXmlHttp.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) { //nếu trạng thái của response ready và ok
                console.log(this.responseText);
                var vJSONNewDiceResponse = JSON.parse(this.responseText); // chuyển thành object
                displayNewDiceResponseInConsole(vJSONNewDiceResponse); // hiển thị dữ liệu phản hồi new dice ra console
                displayDiceAndNotifInWeb(vJSONNewDiceResponse); // hiển thị dice và thông báo ra web
                displayVoucherInWeb(vJSONNewDiceResponse); // hiển thị voucher ra web
                displayPrizeInWeb(vJSONNewDiceResponse); // hiển thị quà tặng ra web
            }
        }
    }
}    
function onBtnDiceHistoryClick() { // hàm chạy khi ấn nút dice history
    console.log("%cNút dice history được ấn", "color:red");
    var vUserDataObj = {
        username: "",
        firstName: "",
        lastName: ""
    };
    getUserDataFromWeb(vUserDataObj); // lấy dữ liệu nhập từ web
    console.log("Ghi tạm dữ liệu nhập ra console");
    console.log(vUserDataObj);
    var vCheckResult = validateUserDataFromWeb(vUserDataObj); // kiểm tra dữ liệu nhập từ web
    console.log("Kết quả kiểm tra dữ liệu nhập là: " + vCheckResult);
    if (vCheckResult == true) {
        var vXmlHttp = new XMLHttpRequest(); // tạo request dice history
        callApiGetDiceHistory(vXmlHttp, vUserDataObj); // mở và gửi request dice history
        vXmlHttp.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                console.log(this.responseText);
                var vJSONDiceHistoryResponse = JSON.parse(this.responseText); // chuyển thành object
                displayDiceHistoryResponseInConsole(vJSONDiceHistoryResponse); // hiển thị dữ liệu phản hồi dice history ra console
                deleteTableAndCreateNewHeader("dice-history"); // xóa bảng và tạo header mới cho phù hợp dice history
                displayDiceHistoryInTable(vJSONDiceHistoryResponse);
            }
        }
    }
}
/*** Vùng 4: hàm dùng chung ***/
function getUserDataFromWeb(paramUserDataObj) { // hàm lấy dữ liệu nhập từ web
    paramUserDataObj.username = $("#input-username").val().trim();
    paramUserDataObj.firstName = $("#input-first-name").val().trim();
    paramUserDataObj.lastName = $("#input-last-name").val().trim();
}
function validateUserDataFromWeb(paramUserDataObj) { // hàm kiểm tra dữ liệu nhập từ web
    var vCheckResult = false;
    if (paramUserDataObj.username == "") {
        alert("Chưa nhập username")
    }
    else if (paramUserDataObj.firstName == "") {
        alert("Chưa nhập first name")
    }
    else if (paramUserDataObj.lastName == "") {
        alert("Chưa nhập last name")
    }
    else {
        vCheckResult = true
    }
    return vCheckResult
}
function callApiGetNewDice(paramRequest, paramUserDataObj) { // hàm xử lý request new dice
    paramRequest.open("POST", gBASE_URL + "/dice", true);
    paramRequest.setRequestHeader("Content-Type", gUTF8_TEXT_APPLICATION_HEADER);
    paramRequest.send(JSON.stringify(paramUserDataObj));  //chuyển Json object sang string
}
function displayNewDiceResponseInConsole(paramResponse) { // hàm hiển thị dữ liệu phản hồi new dice ra console
    if (paramResponse.voucher != null) {
        console.log("Voucher Id: " + paramResponse.voucher.id + ", mã voucher: " + paramResponse.voucher.maVoucher
                + ", phần trăm giảm giá: " + paramResponse.voucher.phanTramGiamGia + ", ghi chú: " + paramResponse.voucher.ghiChu);
    }
    else {
        console.log("Không trúng voucher")
    }
    console.log("Số mặt xúc xắc là: " + paramResponse.dice);
    if (paramResponse.prize != null) {
        console.log("Quà tặng: " + paramResponse.prize);
    }
    else {
        console.log("Không trúng quà tặng")
    }
}
function displayDiceAndNotifInWeb(paramResponse) { // hàm hiển thị dice và thông báo ra web
    var vDice = paramResponse.dice;
    $("#img-dice").prop("src", "LuckyDiceImages/" + vDice + ".png");
    $("#p-notification-dice").html("Chúc mừng. Xúc xắc bạn tung được là: " + vDice);
}
function displayVoucherInWeb(paramResponse) { // hàm hiển thị voucher ra web
    var vPVoucherId = $("#p-voucher-id");
    var vPVoucherPercent = $("#p-voucher-percent");
    if (paramResponse.voucher == null) {
        vPVoucherId.html("Không có Voucher")
    }
    else {
        vPVoucherId.html("Id: " + paramResponse.voucher.id);
        vPVoucherPercent.html("Giảm " + paramResponse.voucher.phanTramGiamGia + "%")
    }
}
function displayPrizeInWeb(paramResponse) { // hàm hiển thị quà tặng ra web
    var vImgPresent = $("#img-present");
    if (paramResponse.prize == null) {
        vImgPresent.prop("src", "LuckyDiceImages/no-present.jpg")
    }
    else if (paramResponse.prize == "Áo") {
        vImgPresent.prop("src", "LuckyDiceImages/t-shirt.jpg")
    }
    else if (paramResponse.prize == "Mũ") {
        vImgPresent.prop("src", "LuckyDiceImages/hat.jpg")
    }
    else if (paramResponse.prize == "Ô tô") {
        vImgPresent.prop("src", "LuckyDiceImages/car.jpg")
    }
    else if (paramResponse.prize == "Xe máy") {
        vImgPresent.prop("src", "LuckyDiceImages/xe-may.jpg")
    }
}
function callApiGetDiceHistory(paramRequest, paramUserDataObj) { // hàm xử lý request dice history
    paramRequest.open("GET", gBASE_URL + "/dice-history?username=" + paramUserDataObj.username, true);
    paramRequest.send();
}
function displayDiceHistoryResponseInConsole(paramResponse) { // hàm hiển thị dữ liệu phản hồi dice history ra console
    if (paramResponse.dices == "") {
        console.log("Chưa ném xúc xắc lần nào")
    }
    else {
        var vTextToDisplay = "Lần 1: " + paramResponse.dices[0];
        for (var bI = 1; bI < paramResponse.dices.length; bI ++) {
            vTextToDisplay += "; lần " + (bI+1) + ": " + paramResponse.dices[bI]
        }
        console.log(vTextToDisplay)
    }
}
function deleteTableAndCreateNewHeader(paramHistory) { // hàm xóa bảng và tạo header mới tùy theo tham số history muốn hiển thị
    var vTable = $("#table-history"); // truy xuất bảng
    var vTableHeader = vTable.children("thead") // truy xuất header của bảng
                    .html("") // xóa hết header
                    .append($("<tr>").append($("<th>").html("Lượt"))); // thêm tr mới; trong tr mới, thêm th có innerHtml là Lượt
    
    if (paramHistory == "dice-history") {
        vTableHeader.children("tr").append($("<th>").html("Dice")) // trong tr mới, thêm th mới có innerHtml là Dice
    }
    else if (paramHistory == "voucher-history") {
        vTableHeader.children("tr").append($("<th>").html("Voucher")) // trong mới tr, thêm th mới có innerHtml là Voucher
    }
    else if (paramHistory == "prize-history") {
        vTableHeader.children("tr").append($("<th>").html("Present")) // trong tr mới, thêm th mới có innerHtml là Present
    }

    vTable.children("tbody").html(""); // xóa hết body của bảng
}
function displayDiceHistoryInTable(paramResponse) { // hiển thị dice history ra bảng
    var vTable = $("#table-history"); // truy xuất bảng
    var vTableBody = vTable.children("tbody"); // truy xuất body của bảng
    var vDiceList = paramResponse.dices; // truy xuất mảng dices của response object

    for (var bI = 0; bI < vDiceList.length; bI ++) {
        vTableBody.append($("<tr>")     // trong tbody, thêm tr mới
            .append($("<td>").html(bI + 1)) // trong tr mới, thêm td là số lượt
            .append($("<td>").html(vDiceList[bI])) // trong tr mới, thêm td là số chấm xúc xắc
        )
    }
}
</script>
</html>
